Skip to main content
POST
/
org
/
api_keys
JavaScript
import Kernel from '@onkernel/sdk';

const client = new Kernel({
  apiKey: process.env['KERNEL_API_KEY'], // This is the default and can be omitted
});

const createdAPIKey = await client.apiKeys.create({ name: 'staging' });

console.log(createdAPIKey);
import os
from kernel import Kernel

client = Kernel(
api_key=os.environ.get("KERNEL_API_KEY"), # This is the default and can be omitted
)
created_api_key = client.api_keys.create(
name="staging",
)
print(created_api_key)
package main

import (
"context"
"fmt"

"github.com/kernel/kernel-go-sdk"
"github.com/kernel/kernel-go-sdk/option"
)

func main() {
client := kernel.NewClient(
option.WithAPIKey("My API Key"),
)
createdAPIKey, err := client.APIKeys.New(context.TODO(), kernel.APIKeyNewParams{
Name: "staging",
})
if err != nil {
panic(err.Error())
}
fmt.Printf("%+v\n", createdAPIKey)
}
curl --request POST \
--url https://api.onkernel.com/org/api_keys \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"name": "staging",
"days_to_expire": 30,
"project_id": "proj_abc123"
}
'


{
  "id": "ckv9w8q2f000001l5r3j7k9m4",
  "name": "production",
  "created_at": "2023-11-07T05:31:56Z",
  "created_by": {
    "id": "user-abc123",
    "email": "user@example.com",
    "name": "Jane Doe"
  },
  "expires_at": "2023-11-07T05:31:56Z",
  "deleted_at": "2023-11-07T05:31:56Z",
  "project_id": "proj_abc123",
  "project_name": "Production",
  "masked_key": "sk_1234...abcd",
  "key": "sk_1234abcd"
}
{
"code": "bad_request",
"message": "Missing required field: app_name",
"details": [
{
"code": "invalid_input",
"message": "Provided version string is not semver compliant"
}
],
"inner_error": {
"code": "invalid_input",
"message": "Provided version string is not semver compliant"
}
}
{
"code": "bad_request",
"message": "Missing required field: app_name",
"details": [
{
"code": "invalid_input",
"message": "Provided version string is not semver compliant"
}
],
"inner_error": {
"code": "invalid_input",
"message": "Provided version string is not semver compliant"
}
}
{
"code": "bad_request",
"message": "Missing required field: app_name",
"details": [
{
"code": "invalid_input",
"message": "Provided version string is not semver compliant"
}
],
"inner_error": {
"code": "invalid_input",
"message": "Provided version string is not semver compliant"
}
}
{
"code": "bad_request",
"message": "Missing required field: app_name",
"details": [
{
"code": "invalid_input",
"message": "Provided version string is not semver compliant"
}
],
"inner_error": {
"code": "invalid_input",
"message": "Provided version string is not semver compliant"
}
}

Authorizations

Authorization
string
header
required

Bearer authentication header of the form Bearer <token>, where <token> is your auth token.

Body

application/json
name
string
required

Label for the API key (1-255 characters). API keys are not addressable by name.

Required string length: 1 - 255
Example:

"staging"

days_to_expire
integer | null

Number of days until expiry, up to 3650. Use null for never.

Required range: 1 <= x <= 3650
Example:

30

project_id
string | null

Unique project identifier

Example:

"proj_abc123"

Response

API key created successfully

API key returned immediately after creation. Includes the plaintext key once.

id
string
required

Unique API key identifier

Example:

"ckv9w8q2f000001l5r3j7k9m4"

name
string
required

Label for the API key. API keys are not addressable by name; use the ID or key identifier for stable references.

Example:

"production"

created_at
string<date-time>
required

When the API key was created

created_by
object
required
expires_at
string<date-time> | null
required

When the API key expires

deleted_at
string<date-time> | null
required

When the API key was deleted (soft-deleted). Null for keys that have not been deleted.

project_id
string | null
required

Project identifier for project-scoped API keys. Null means org-wide.

Example:

"proj_abc123"

project_name
string | null
required

Project name for project-scoped API keys. Null means the key is org-wide or the project name is unavailable.

Example:

"Production"

masked_key
string
required

Masked version of the API key

Example:

"sk_1234...abcd"

key
string
required

Plaintext API key. Only returned once when the key is created.

Example:

"sk_1234abcd"